apps/adopcion/urls.py
from django.urls import path
from apps.adopcion.views import index_adopcion, SolicitudList,SolicitudCreate, SolicitudUpdate, SolicitudDelete
app_name = "solicitud"
urlpatterns = [
    path('',index_adopcion, name='index_adopcion'),
    path('listar',SolicitudList.as_view(), name='solicitud_listar'),
    path('crear',SolicitudCreate.as_view(), name='solicitud_crear'),
    path('editar/<pk>',SolicitudUpdate.as_view(), name='solicitud_editar'),
    path('eliminar/<pk>',SolicitudDelete.as_view(), name='solicitud_eliminar'),
]

apps/mascota/urls.py
from django.urls import path
from apps.mascota.views import index, mascota_view, mascota_list, mascota_edit, mascota_delete, \
    MascotaList, MascotaCreate, MascotaUpdate, MascotaDelete
from django.contrib.auth.decorators import login_required

app_name = "mascota"
urlpatterns = [
    path('', index, name='index'),
    # path('nuevo', mascota_view, name='mascota_crear'),
    path('nuevo', login_required(MascotaCreate.as_view()), name='mascota_crear'),
    # path('listar', mascota_list, name='mascota_listar'),
    path('listar', login_required(MascotaList.as_view()), name='mascota_listar'),
    # path('editar/<id_mascota>', mascota_edit, name='mascota_editar'),
    path('editar/<pk>', login_required(MascotaUpdate.as_view()), name='mascota_editar'),
    path('eliminar/<pk>', login_required(MascotaDelete.as_view()), name='mascota_eliminar'),
]

refugio/urls.py
from django.contrib import admin
from django.urls import path, include
from django.contrib.auth.views import LoginView, logout_then_login, PasswordResetView, PasswordResetDoneView, PasswordResetConfirmView, PasswordResetCompleteView


urlpatterns = [
    path('admin/', admin.site.urls),
    path('mascota/', include('apps.mascota.urls'), name='mascota'),
    path('solicitud/', include('apps.adopcion.urls'), name='solicitud'),
    path('usuario/', include('apps.usuario.urls'), name='usuario'),
    path('accounts/login/', LoginView.as_view(), name='login'),
    path('logout', logout_then_login, name='logout'),

    path('password_reset/reset', PasswordResetView.as_view(), name='password_reset'),
    path('password_reset/done', PasswordResetDoneView.as_view(), name='password_reset_done'),
    path('password_reset/confirm/<uidb64>/<token>', PasswordResetConfirmView.as_view(), name='password_reset_confirm'),
    path('passwprd_reset/done', PasswordResetCompleteView.as_view(), name='password_reset_complete'),
]

apps/adopcion/models.py
from django.db import models

# Create your models here.

class Persona(models.Model):
    nombre = models.CharField(max_length=50)
    apellidos = models.CharField(max_length=70)
    edad = models.IntegerField()
    telefono = models.CharField(max_length=12)
    email = models.EmailField()
    domicilio = models.TextField()

    def __str__(self):
        return '{}'.format(self.nombre,self.apellidos)

class Solicitud(models.Model):
    persona = models.ForeignKey(Persona, null=True, blank=True, on_delete=models.CASCADE)
    numero_mascotas = models.IntegerField()
    razones = models.TextField()

apps/adopcion/forms.py
from django import forms
from apps.adopcion.models import Persona, Solicitud


class PersonaForm(forms.ModelForm):
    class Meta:
        model = Persona
        fields = [
            'nombre',
            'apellidos',
            'edad',
            'telefono',
            'email',
            'domicilio',
        ]
        fields = {
            'nombre': 'Nombre',
            'apellidos': 'Apellidos',
            'edad': 'Edad',
            'telefono': 'Telefono',
            'email': 'Email',
            'domicilio': 'Domicilio',
        }
        widgets = {
            'nombre': forms.TextInput(attrs={'class': 'form-control'}),
            'apellidos': forms.TextInput(attrs={'class': 'form-control'}),
            'edad': forms.TextInput(attrs={'class': 'form-control'}),
            'telefono': forms.TextInput(attrs={'class': 'form-control'}),
            'email': forms.TextInput(attrs={'class': 'form-control'}),
            'domicilio': forms.TextInput(attrs={'class': 'form-control'}),
        }


class SolicitudForm(forms.ModelForm):
    class Meta:
        model = Solicitud
        fields = [
            'numero_mascotas',
            'razones',
        ]
        labels = {
            'numero_mascotas': 'Numero de mascotas',
            'razones': 'Razones para adoptar',
        }
        widgets = {
            'numero_mascotas': forms.TextInput(attrs={'class': 'form-control'}),
            'razones': forms.TextInput(attrs={'class': 'form-control'}),
        }

apps/adopcion/views.py
from django.shortcuts import render
from django.http import HttpResponseRedirect, HttpResponse
from django.views.generic import ListView, CreateView, UpdateView, DeleteView
from django.urls import reverse, reverse_lazy

from apps.adopcion.models import Solicitud, Persona
from apps.adopcion.forms import PersonaForm, SolicitudForm




# Create your views here.

def index_adopcion(request):
    return HttpResponse("Pagina principal de la app adopcion")


class SolicitudList(ListView):
    model = Solicitud
    template_name = 'adopcion/solicitud_list.html'


class SolicitudCreate(CreateView):
    model = Solicitud
    template = 'adopcion/solicitud_form.html'
    form_class = SolicitudForm
    second_form_class = PersonaForm
    success_url = reverse_lazy('solicitud:solicitud_listar')

    def get_context_data(self, **kwargs):
        context = super(SolicitudCreate, self).get_context_data(**kwargs)
        if 'form' not in context:
            context['form'] = self.form_class(self.request.GET)
        if 'form2' not in context:
            context['form2'] = self.second_form_class(self.request.GET)
        return context

    def post(self, request, *args, **kwargs):
        self.object = self.get_object
        form = self.form_class(request.POST)
        form2 = self.second_form_class(request.POST)

        if form.is_valid() and form2.is_valid():
            solicitud = form.save(commit=False)
            solicitud.persona = form2.save()
            solicitud.save()
            return HttpResponseRedirect(self.get_success_url())
        else:
            return self.render_to_response(self.get_context_data(form=form, form2=form2))


class SolicitudUpdate(UpdateView):
    model = Solicitud
    second_model = Persona
    template_name = 'adopcion/solicitud_form.html'
    form_class = SolicitudForm
    second_form_class = PersonaForm
    success_url = reverse_lazy('solicitud:solicitud_listar')

    def get_context_data(self, **kwargs):
        context = super(SolicitudUpdate, self).get_context_data(**kwargs)
        pk = self.kwargs.get('pk', 0)
        solicitud = self.model.objects.get(id=pk)
        persona = self.second_model.objects.get(id=solicitud.persona_id)
        if 'form' not in context:
            context['form'] = self.form_class()
        if 'form2' not in context:
            context['form2'] = self.second_form_class(instance=persona)

        context['id'] = pk
        return context

    def post(self, request, *args, **kwargs):
        self.object = self.get_object
        id_solicitud = kwargs['pk']
        solicitud = self.model.objects.get(id=id_solicitud)
        persona = self.second_model.objects.get(id=solicitud.persona_id)
        form = self.form_class(request.POST, instance=solicitud)
        form2 = self.second_form_class(request.POST, instance=persona)

        if form.is_valid() and form2.is_valid():
            form.save()
            form2.save()
            return HttpResponseRedirect(self.get_success_url())
        else:
            return self.render_to_response(self.get_context_data(form=form, form2=form2))

class SolicitudDelete(DeleteView):
    model = Solicitud
    template_name = 'adopcion/solicitud_delete.html'
    success_url = reverse_lazy('solicitud:solicitud_listar')

templates/adopcion/solicitud_delete.html
{% extends 'base/base.html' %}

{% block content %}
    <form method="post">
        <!--muy importante el token-->
        {% csrf_token %}
        <h3>¿Deseas eliminar el registro de {{ object.persona.nombre }} {{ object.persona.apellidos }}?</h3>
        <button class="btn btn-danger" type="submit">Eliminar</button>
        <a class="btn btn-default" href="{%  url 'mascota:mascota_listar' %}">Cancelar</a>
    </form>
{% endblock %}

templates/adopcion/solicitud_form.html
{% extends 'base/base.html' %}
{% block content %}
    <form method="post">
        {% csrf_token %}
        <div class="row">
            <div class="col-md-8 col-md-offset-2">
                <div class="form-group">
                    <label for="{{ form2.nombre.name }}">{{ form2.nombre.label }}</label>
                    {{ form2.nombre }}
                </div>
            </div>
            <div class="col-md-8 col-md-offset-2">
                <div class="form-group">
                    <label for="{{ form2.nombre.apellidos }}">{{ form2.apellidos.label }}</label>
                    {{ form2.apellidos }}
                </div>
            </div>
            <div class="col-md-8 col-md-offset-2">
                <div class="form-group">
                    <label for="{{ form2.edad.name}}">{{ form2.edad.name }}</label>
                    {{ form2.edad }}
                </div>
            </div>
            <div class="col-md-8 col-md-offset-2">
                <div class="form-group">
                    <label for="{{ form2.email.name }}">{{ form2.email.label }}</label>
                    {{ form2.email}}
                </div>
            </div>
            <div class="col-md-8 col-md-offset-2">
                <div class="form-group">
                    <label for="{{ form2.domicilio.name }}">{{ form2.domicilio.label }}</label>
                    {{ form2.domicilio }}
                </div>
            </div>
            <div class="col-md-8 col-md-offset-2">
                <div class="form-group">
                    <label for="{{ form.numero_mascotas.name }}">{{ form.numero_mascotas.label }}</label>
                    {{ form.numero_mascotas }}
                </div>
            </div>
            <div class="col-md-8 col-md-offset-2">
                <div class="form-group">
                    <label for="{{ form.razones.name }}">{{ form.razones.label }}</label>
                    {{ form.razones }}
                </div>
            </div>
            <div class="col-md-8 col-md-offset-2">
                <div class="form-group">
                    <button class="btn btn-primary" type="submit">Guardar</button>
                </div>
            </div>
        </div>

    </form>
{% endblock%}

templates/adopcion/solicitud_list.html
{% extends 'base/base.html' %}

{% block content %}
    <table class="table table-bordered">
        <thead>
            <tr>
                <td># Solicitud</td>
                <td>Adoptante</td>
                <td>#Mascotas</td>
                <td>Razones</td>
                <td>Acciones</td>
            </tr>
        </thead>

        <tbody>
            {% if object_list %}
            {% for solicitud in object_list %}
            <tr>
                <td>{{ solicitud.id }}</td>
                <td>{{ solicitud.persona.nombre }} {{ solicitud.persona.apellidos }}</td>
                <td>{{ solicitud.numero_mascotas }}</td>
                <td>{{ solicitud.razones}}</td>
                <td>
                    <a class="btn-primary btn" href="#">Editar</a>
                    <a class="btn-danger btn" href="#">Eliminar</a>
                </td>
            </tr>

        {% endfor %}
        {% else %}
        <h1>No hay registros de solicitudes</h1>
        {% endif %}

        </tbody>
    </table>
{% endblock %}